#This function runs every tick to see if the wither is too high and teleports it down half a block if it is

#This function is called directly in main:tick

#This function makes no calls
	
##############################################################################################

# First this functions schedules itself to run again.
	# By default, once every five minutes
		schedule function downwither:tick 300s
	# If there is a problematic wither, it instead reschedules itself to occur every tick, as long as the wither remains problematic.	
		execute as @e[tag=problematicWither] run schedule clear downwither:tick
		execute as @e[tag=problematicWither] run schedule function downwither:tick 1

# Second, this Function checks if there is a wither which is problematic
	# That is both above y=154 and standing on minecraft:air
			# and It tags any such wither found as problematic.
		execute as @e[type=minecraft:wither, predicate=downwither:above_wither_ceiling] run tag @s add problematicWither
#		execute as @e[type=minecraft:wither, predicate=downwither:above_wither_ceiling, tag=!problematicWither] run say taggin' it.

# Third, this function checks if there is any problematic wither which has had its' problem resolved.
		execute as @e[tag=problematicWither, predicate=downwither:significantly_below_wither_ceiling] run tag @s remove problematicWither

# Finally, if there is still a problematic wither, this function 
	# Checks if N blocks below the wither are air (or an air-like block, eg short_grass, #saplings)
			# The top most option checks the block its in aall five block below it, which closly emulates the vanilla behavior of floating out of a standing player's melee range while preventing futher excessive altitude gain.
				# If you would prefer to be able to melee the wither, use one of the other statements which force it to float closer to the ground (and therefore in melee range). 
	# teleport it down a small amount.
			# A wither that is below at @p ~ ~5 ~ will attempt to increase it's y value by .3 blocks per tick.
				# Downporting by       any number will allow a wither that wants to descend to do so, and at a faster  rate.
				# Downporting by a smaller number will allow a wither that wants to  ascend to do so, but at a reduced rate. 
				# Downporting by a  larger number will force a wither that wants to  ascend to descend instead.			
		execute as @e[tag=problematicWither, predicate=downwither:above_wither_ceiling] at @s if block ~ ~-5 ~ #downwither:wither_transparent if block ~ ~-4 ~ #downwither:wither_transparent if block ~ ~-3 ~ #downwither:wither_transparent if block ~ ~-2 ~ #downwither:wither_transparent if block ~ ~-1 ~ #downwither:wither_transparent if block ~ ~ ~ #downwither:wither_transparent run teleport @s ~ ~-0.3 ~
#		execute as @e[tag=problematicWither, predicate=downwither:above_wither_ceiling] at @s if block ~ ~-4 ~ #downwither:wither_transparent if block ~ ~-3 ~ #downwither:wither_transparent if block ~ ~-2 ~ #downwither:wither_transparent if block ~ ~-1 ~ #downwither:wither_transparent if block ~ ~ ~ #downwither:wither_transparent run teleport @s ~ ~-0.3 ~
#		execute as @e[tag=problematicWither, predicate=downwither:above_wither_ceiling] at @s if block ~ ~-3 ~ #downwither:wither_transparent if block ~ ~-2 ~ #downwither:wither_transparent if block ~ ~-1 ~ #downwither:wither_transparent if block ~ ~ ~ #downwither:wither_transparent run teleport @s ~ ~-0.3 ~
#		execute as @e[tag=problematicWither, predicate=downwither:above_wither_ceiling] at @s if block ~ ~-2 ~ #downwither:wither_transparent if block ~ ~-1 ~ #downwither:wither_transparent if block ~ ~ ~ #downwither:wither_transparent run teleport @s ~ ~-0.3 ~
#		execute as @e[tag=problematicWither, predicate=downwither:above_wither_ceiling] at @s if block ~ ~-1 ~ #downwither:wither_transparent if block ~ ~ ~ #downwither:wither_transparent run teleport @s ~ ~-0.3 ~
#		execute as @e[tag=problematicWither, predicate=downwither:above_wither_ceiling] at @s if block ~ ~ ~ #downwither:wither_transparent run teleport @s ~ ~-0.3 ~
